#!/bin/bash
#
#   Hitachi Fibre Channel Adapter Driver Installer for Linux IA32/IA64
#
#   $Header: /home/cvs_linux/tools/install/Attic/hfcinst_tools.sh,v 1.1.2.5.2.2 2008/02/19 20:17:46 tteraya Exp $
#   $Log: hfcinst_tools.sh,v $
#   Revision 1.1.2.5.2.2  2008/02/19 20:17:46  tteraya
#
#   feedback hsdldd
#
#   Revision 1.1.2.5.2.1  2008/02/19 14:39:26  tteraya
#
#   feedback x.x.10.492
#
#   Revision 1.1.2.5  2007/11/07 05:09:24  nkubota
#   FCLNX-0455 RASLOG support
#
#   Revision 1.1.2.4  2007/07/11 03:32:10  nkubota
#   FCLNX-0422 hfcldd and hfcldd_conf with non-GPL
#
#   Revision 1.1.2.3  2007/07/03 07:40:34  nkubota
#   FCLNX-0419
#
#   Revision 1.1.2.2  2007/06/07 07:32:00  nkubota
#   FCLNX-0411,FCLNX-0412
#
#   Revision 1.1.2.1  2007/06/05 01:49:33  nkubota
#   Release GPL
#
#
if [ "$1" != "install" -a "$1" != "uninstall" ]; then
        echo "Usage : hfcinst_tools.sh install/uninstall [Kernel-Version]"  
        echo "example(install  ) : hfcinst_tools.sh install" 
        echo "       (uninstall) : hfcinst_tools.sh uninstall" 
        exit 1
fi
HFCMKNOD="hfcmknod"
TOOLSDIR="/opt/hitachi/drivers/hba"
INSTLOG="/tmp/hfcldd_install.log"
KERNELMIN=`uname -r | sed -e 's,[^\.]*\.,,' -e 's,\..*,,'`
if [ "$HOSTTYPE" = "ia64" ]; then
	BOOTDIR="boot/efi/efi/redhat"
else
	BOOTDIR="boot"
fi
echo "      Boot directory      : $BOOTDIR" >> $INSTLOG
if [ -n "$2" ]; then
	KERNVER=$2
else
	KERNVER=`uname -r`
fi
if [ $KERNELMIN = "6" ]; then
	MODCONF="modprobe.conf"
	if [ ! -f "/etc/$MODCONF" ]; then
		echo " ---- No configuration file was found (/etc/$MODCONF)"  >> $INSTLOG
		exit 1
	fi
	DRVNAME="hfcldd.ko"
	CNFNAME="hfcldd_conf.ko"
else
	MODCONF="modules.conf"
	if [ ! -f "/etc/$MODCONF" ]; then
		echo " ---- No configuration file was found (/etc/$MODCONF)"  >> $INSTLOG
		exit 1
	fi
	DRVNAME="hfcldd.o"
	CNFNAME="hfcldd_conf.o"
fi
LIBMODULE="/lib/modules/$KERNVER/kernel/drivers"
if [ ! -d "$LIBMODULE" ]; then
	echo " @ERR install directry($LIBMODULE) not found" >> $INSTLOG
	if [ -n "$2" ]; then
	echo "      Kernel $2 not installed." >> $INSTLOG
	fi
	exit 1
fi
echo "      Kernel version      : $KERNVER"   >> $INSTLOG
echo "      Host Type           : `uname -m`"   >> $INSTLOG
if [ "$1" = "install" ]; then
	echo " ---- Install  @Utilities for Hitachi Fibre Channel Adapter Driver - `date`" >> $INSTLOG
	echo "     Install tools and scripts to /opt/hitachi/drivers/hba and /etc/init.d "   >> $INSTLOG
	install -d -o root -g root $TOOLSDIR     
	install -o root -g root tools/* $TOOLSDIR
	if [ -f "/opt/hitachi/drivers/hba/hfcddutil" ]; then
		echo "      Replace /opt/hitachi/drivers/hba/hfcddutil as hfcmputil"   >> $INSTLOG
		rm -f /opt/hitachi/drivers/hba/hfcddutil
	fi
	ln -s /opt/hitachi/drivers/hba/hfcmputil /opt/hitachi/drivers/hba/hfcddutil
	install -o root -g root $HFCMKNOD /etc/init.d/
	/sbin/chkconfig --add hfcmknod
	echo "      Migrate from /etc/$MODCONF to /etc/hfcldd.conf"   >> $INSTLOG
	tools/hfcmputil -y >> $INSTLOG
	tools/hfcmpcfg -w hfcldd_conf -f $LIBMODULE/scsi/$CNFNAME >> $INSTLOG
	cp /$BOOTDIR/initrd-$KERNVER.img /$BOOTDIR/initrd-$KERNVER.img.backup
	echo "      Update boot image file /$BOOTDIR/initrd-$KERNVER.img"         >> $INSTLOG
	echo "      old boot image file --> /$BOOTDIR/initrd-$KERNVER.img.backup" >> $INSTLOG
	echo "        /sbin/mkinitrd -f /$BOOTDIR/initrd-$KERNVER.img $KERNVER"   >> $INSTLOG
	/sbin/mkinitrd -f /$BOOTDIR/initrd-$KERNVER.img $KERNVER
#	if [ $KERNELMIN = "4" ]; then
#		if [ "$KERNVER" = `uname -r` ]; then
#			echo "      check loaded modules"   >> $INSTLOG
#			COUNT=`/sbin/lsmod | grep hfcldd | wc -l`
#			NUM=`expr $COUNT`
#			if [ $NUM -eq 0 ]; then
#				echo "      Make special file"   >> $INSTLOG
#				/etc/init.d/hfcmknod >> $INSTLOG
#				if [ $? -ne 0 ]; then
#					exit 1
#				fi
#			fi
#		fi
#	fi
	cp hfcinst_tools.sh /opt/hitachi/drivers/hba 
	echo " ---- Install Success "   >> $INSTLOG
else
	echo " ---- Uninstall  @Utilities for Hitachi Fibre Channel Adapter Driver - `date`"   >> $INSTLOG
	echo "        hfcmknod stop"   >> $INSTLOG
	if [ -f /etc/init.d/hfcmknod ]; then
		/etc/init.d/hfcmknod stop >> $INSTLOG
		if [ $? -ne 0 ]; then
			exit 1
		fi
	fi
	/sbin/chkconfig --del hfcmknod
	rm -f /etc/init.d/$HFCMKNOD
	echo "        remove tools from /opt/hitachi/drivers/hba"   >> $INSTLOG
	rm -f $TOOLSDIR/ddd* fwtrc hfcbios hfcddutil hfcinst_tools.sh hfclo hfcmcup hfcmp* *.txt version* hfcldd_err hfcrasinfo
    echo " ---- Uninstall Success "   >> $INSTLOG
fi
